//+-----------------------------------------------------------------+
//| Price Zone 1                                                    |
//| Original auther is unknown, modification by -IXI-.              |
//+-----------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 9
#property indicator_color1  clrBlue       //LimeGreen
#property indicator_color2  clrOrangeRed    
#property indicator_color3  clrOrange
#property indicator_color4  clrLightSlateGray
#property indicator_color5  clrLightSlateGray
#property indicator_color6  clrLightSlateGray
#property indicator_color7  clrLightSlateGray
#property indicator_color8  clrLightSlateGray
#property indicator_color9  clrLightSlateGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  1
#property indicator_width9  1
//---- Input Parameters
extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT; // Time frame
extern int             Length          = 20;
extern double          Deviation1      = 2.0;
extern double          Deviation2      = 3.0;
extern double          Deviation3      = 4.0;
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = false;
extern bool            alertsOnHighLow = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern bool            Interpolate     = true;           // Interpolate in multi time frame mode?


//---- Buffers
double Middle[];
double MiddleI[];
double MiddleII[];
double Upper1[];
double Lower1[];
double Upper2[];
double Lower2[];
double Upper3[];
double Lower3[];
double Slope[];
double trend[];
string indicatorFileName;
bool   returnBars;

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

int init()
  {
   IndicatorBuffers(11);
   SetIndexBuffer(0,Middle);
   SetIndexBuffer(1,MiddleI);
   SetIndexBuffer(2,MiddleII);
   SetIndexBuffer(3,Upper1);
   SetIndexBuffer(4,Lower1);
   SetIndexBuffer(5,Upper2);
   SetIndexBuffer(6,Lower2);
   SetIndexBuffer(7,Upper3);
   SetIndexBuffer(8,Lower3);
   SetIndexBuffer(9,Slope);
   SetIndexBuffer(10,trend);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99; 
      TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName("Price Zone("+Length+")");
   return(0);
  }
int deinit() { return(0); }

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Middle[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == _Period)
   {
       if (Slope[limit]==-1) CleanPoint(limit,MiddleI,MiddleII);
      for (int i = limit; i>=0; i--)
      {	
         double CloseMA     = iEma(Close[i]      ,Length,i,0);
	      double HLMA        = iEma(High[i]-Low[i],Length,i,1);
	      double APZRange    = iEma(HLMA          ,Length,i,2);
	             Middle[i]   = iEma(CloseMA       ,Length,i,3);
	             Upper1[i]   = Middle[i]+APZRange*Deviation1;
	             Lower1[i]   = Middle[i]-APZRange*Deviation1;
	             Upper2[i]   = Middle[i]+APZRange*Deviation2;
	             Lower2[i]   = Middle[i]-APZRange*Deviation2;
	             Upper3[i]   = Middle[i]+APZRange*Deviation3;
	             Lower3[i]   = Middle[i]-APZRange*Deviation3;
	             Slope[i]    = Slope[i+1];
	             MiddleI[i]  = EMPTY_VALUE;
	             MiddleII[i] = EMPTY_VALUE;
   	             if (Middle[i] > Middle[i+1]) Slope[i] =  1;
                   if (Middle[i] < Middle[i+1]) Slope[i] = -1;
                   if (Slope[i] == -1) PlotPoint(i,MiddleI,MiddleII,Middle);
                   trend[i] = 0;                     
                   if (alertsOnHighLow)       
                   {
                     if (High[i] > Upper1[i])  trend[i] = -1;
                     if (Low[i]  < Lower1[i])  trend[i] =  1;
                   }
                   else
                   {
                     if (Close[i] > Upper1[i]) trend[i] = -1;
                     if (Close[i] < Lower1[i]) trend[i] =  1;
                   }
   }
   manageAlerts();
	return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
   if (Slope[limit]==-1) CleanPoint(limit,MiddleI,MiddleII);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);           
         Middle[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,0,y);
	      MiddleI[i]  = EMPTY_VALUE;
	      MiddleII[i] = EMPTY_VALUE;
         Upper1[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,3,y);
         Lower1[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,4,y);
         Upper2[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,5,y);
         Lower2[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,6,y);
         Upper3[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,7,y);
         Lower3[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,8,y);
         Slope[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Deviation1,Deviation2,Deviation3,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,9,y);
         
	      
	      if (!Interpolate ||  (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //
      
         int n,k; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(k = 1; i+n < Bars && i+k < Bars && k < n; k++) 
            {
               Middle[i+k] = Middle[i] + (Middle[i+n] - Middle[i])*k/n;
               Upper1[i+k] = Upper1[i] + (Upper1[i+n] - Upper1[i])*k/n;
               Lower1[i+k] = Lower1[i] + (Lower1[i+n] - Lower1[i])*k/n;
               Upper2[i+k] = Upper2[i] + (Upper2[i+n] - Upper2[i])*k/n;
               Lower2[i+k] = Lower2[i] + (Lower2[i+n] - Lower2[i])*k/n;
               Upper3[i+k] = Upper3[i] + (Upper3[i+n] - Upper3[i])*k/n;
               Lower3[i+k] = Lower3[i] + (Lower3[i+n] - Lower3[i])*k/n;        
            }
     }
     for (i=limit; i>=0; i--) if (Slope[i] == -1) PlotPoint(i,MiddleI,MiddleII,Middle);
return(0);
}
     
//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

double workEma[][4];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"lower");
         if (trend[whichBar] ==-1) doAlert(whichBar,"upper");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(_Period)+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Price Zone price touching ",doWhat," band");
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Price Zone "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}